summaryrefslogtreecommitdiffstats
path: root/generate-metrics-report.sh
diff options
context:
space:
mode:
authordanielhanrahan <daniel.hanrahan@est.tech>2023-03-05 12:20:40 +0000
committersourabh_sourabh <sourabh.sourabh@est.tech>2023-03-20 15:55:40 +0000
commit9c8b57d4ff1c8a70c65d04694cb1c164c5e770ad (patch)
tree4dc1c0265fecf1ca88fea433cdf5f2243d375d01 /generate-metrics-report.sh
parent0b00f81b98e5fa9632b1145e49f62d0b2712f4e4 (diff)
Script to diff metrics reports
- Added Python script to subtract metrics reports - Moved scripts to test-tools/ folder Issue-ID: CPS-1551 Signed-off-by: danielhanrahan <daniel.hanrahan@est.tech> Change-Id: I4547eb523135dfc0441b5d47ab7f81b184bf836a
Diffstat (limited to 'generate-metrics-report.sh')
-rwxr-xr-xgenerate-metrics-report.sh109
1 files changed, 0 insertions, 109 deletions
diff --git a/generate-metrics-report.sh b/generate-metrics-report.sh
deleted file mode 100755
index f1eac14719..0000000000
--- a/generate-metrics-report.sh
+++ /dev/null
@@ -1,109 +0,0 @@
-#!/bin/bash
-#
-# Copyright 2023 Nordix Foundation.
-#
-# Licensed under the Apache License, Version 2.0 (the "License");
-# you may not use this file except in compliance with the License.
-# You may obtain a copy of the License at
-#
-# http://www.apache.org/licenses/LICENSE-2.0
-#
-# Unless required by applicable law or agreed to in writing, software
-# distributed under the License is distributed on an "AS IS" BASIS,
-# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
-# See the License for the specific language governing permissions and
-# limitations under the License.
-#
-
-set -o errexit # Exit on most errors
-set -o nounset # Disallow expansion of unset variables
-set -o pipefail # Use last non-zero exit code in a pipeline
-#set -o xtrace # Uncomment for debugging
-
-function script_usage() {
- cat <<EOF
-Usage:
- -h|--help Displays this help
- -u|--metrics-url=URL URL to Prometheus metrics
- Default: http://localhost:8887/manage/prometheus
- -o|--output=FILE Path to output file
- Default: metrics-reports/metrics-[timestamp].tsv
-EOF
-}
-
-function parse_params() {
- # Set parameter defaults
- METRICS_URL="http://localhost:8887/manage/prometheus"
- OUTFILE="metrics-reports/metrics-$(date --iso-8601=seconds).tsv"
- TEMP_DIR="/tmp/cps-metrics"
-
- # Parse parameters
- local param
- while [[ $# -gt 0 ]]; do
- param="$1"
- shift
- case $param in
- -h | --help)
- script_usage
- exit 0
- ;;
- -u | --metrics-url)
- METRICS_URL=$1
- shift
- ;;
- -o | --output)
- OUTFILE=$1
- shift
- ;;
- *)
- echo "Invalid parameter was provided: $param" >&2
- script_usage
- exit 1
- ;;
- esac
- done
-}
-
-function generate_report() {
- # Create needed directories.
- mkdir -p $TEMP_DIR "$(dirname "$OUTFILE")"
-
- # Scrape raw metrics (suppress progress meter).
- curl --fail --silent --show-error --output $TEMP_DIR/metrics-raw.txt "$METRICS_URL"
-
- # Remove comments, sort by name, and separate by tabs.
- grep --invert-match "^#" $TEMP_DIR/metrics-raw.txt | sort | sed 's/,[}]/}\t/' >$TEMP_DIR/metrics-all.txt
-
- # Extract useful metrics.
- grep -E "^cps_|^spring_data_" $TEMP_DIR/metrics-all.txt >$TEMP_DIR/metrics-cps.txt
-
- # Extract into columns.
- grep "_count" $TEMP_DIR/metrics-cps.txt | sed 's/_count//' | cut -f 1 >$TEMP_DIR/column1.txt
- grep "_count" $TEMP_DIR/metrics-cps.txt | cut -f 2 >$TEMP_DIR/column2.txt
- grep "_sum" $TEMP_DIR/metrics-cps.txt | cut -f 2 >$TEMP_DIR/column3.txt
- grep "_max" $TEMP_DIR/metrics-cps.txt | cut -f 2 >$TEMP_DIR/column4.txt
-
- # Combine columns into report.
- paste $TEMP_DIR/column{1,2,3,4}.txt >$TEMP_DIR/report.txt
-
- # Sort by Sum (column 3), descending.
- sort --general-numeric-sort --reverse --field-separator=$'\t' --key=3 $TEMP_DIR/report.txt >$TEMP_DIR/report-sorted.txt
-
- # Compile final report, with column headers.
- echo -e "Method\tCount\tSum\tMax" >"$OUTFILE"
- cat $TEMP_DIR/report-sorted.txt >>"$OUTFILE"
-
- # Output path to generated file
- echo "$OUTFILE"
-}
-
-function cleanup() {
- rm -f $TEMP_DIR/* && rmdir $TEMP_DIR 2>/dev/null
-}
-# Set up the cleanup function to be triggered upon script exit
-trap cleanup EXIT
-
-# Main script logic
-parse_params "$@"
-generate_report
-exit 0